# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/phy/spacemit,k1-pcie-phy.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: SpacemiT K1 PCIe PHY

maintainers:
  - Alex Elder <elder@riscstar.com>

description: >
  Two PHYs on the SpacemiT K1 SoC used for only for PCIe.  These
  PHYs must be configured using calibration values that are
  determined by a third "combo PHY".  The combo PHY determines
  these calibration values during probe so they can be used for
  the two PCIe-only PHYs.

  The PHY uses an external oscillator as a reference clock.  During
  normal operation, the PCIe host driver is responsible for ensuring
  all other clocks needed by a PHY are enabled, and all resets
  affecting the PHY are deasserted.

properties:
  compatible:
    const: spacemit,k1-pcie-phy

  reg:
    items:
      - description: PHY control registers

  clocks:
    items:
      - description: External oscillator used by the PHY PLL

  clock-names:
    const: refclk

  resets:
    items:
      - description: PHY reset; remains deasserted after initialization

  reset-names:
    const: phy

  "#phy-cells":
    const: 0

required:
  - compatible
  - reg
  - clocks
  - clock-names
  - resets
  - reset-names
  - "#phy-cells"

additionalProperties: false

examples:
  - |
    #include <dt-bindings/clock/spacemit,k1-syscon.h>
    phy@c0c10000 {
        compatible = "spacemit,k1-pcie-phy";
        reg = <0xc0c10000 0x1000>;
        clocks = <&vctcxo_24m>;
        clock-names = "refclk";
        resets = <&syscon_apmu RESET_PCIE1_GLOBAL>;
        reset-names = "phy";
        #phy-cells = <0>;
    };
